// `pXbh

unit Unit2;

interface

uses
  Windows,Classes, Graphics,SysUtils;

type

  TdefData=Record // ݒf[^p\
    sx,sy,jx,jy,range: Extended;
    aka,midori,ao,shuR,shuG,shuB,kyoukai:Integer;
    rn,rc,gn,gc,bn,bc,dd:Integer;
    hanten,mand:Boolean;
  end;

  Tpoints=array[0..399,0..399]of Integer; // EUpz
  Tpixels=array[0..3,0..399] of Integer; // `pcharbg}bv
  TCol=array[0..255] of Integer; // J[

  TRunThread = class(TThread)
  private

    znr,zni,znr2,zni2,dx,dy:Extended;
    px,py,n,nn:Integer;
    clpoints:Tpoints;
    mand,hanten:boolean;
    bmi:TBITMAPINFO;
    pixs:TPixels;
    cols:TCol;
    dwTime1,dwTime2:DWORD;

  protected
    procedure Execute; override;
    procedure clearScreen;
    procedure drawScreen;
    procedure drawEnd;

  Public
    thData: TDefData;
    doing: boolean;
    go: Integer;
    points:Tpoints;
    bSetOnly:boolean;

  end;

implementation

Uses Unit1;

procedure TRunThread.Execute;
var
  i,j,n,aka,midori,ao:Integer;
  mc:Extended;
begin

  bmi.bmiHeader.biSize:=sizeof(TBITMAPINFOHEADER); // chawb_
  bmi.bmiHeader.biWidth:=400;
  bmi.bmiHeader.biHeight:=4;
  bmi.bmiHeader.biPlanes:=1;
  bmi.bmiHeader.biBitCount:=32;
  bmi.bmiHeader.biCompression:=BI_RGB;

  doing:=False;
  go:=0;

  for i:=0 to 399 do // UNApz
    for j:=0 to 399 do
      clpoints[j,i]:=-1;

  points:=clpoints; // UNA

  Suspend; // ݒ肪I~

  while not Terminated do
  begin

    if go=1 then  // `
    begin

      dwTime1:=GetTickCount();

      doing:=True; // `撆tOZbg
      synchronize(clearScreen); // ʃNAƕiݒ

      nn:=(thData.kyoukai+1)*32-1;

      if thData.hanten then
        cols[255]:=RGB(255-thData.ao,255-thData.midori,255-thData.aka)
      else
        cols[255]:=RGB(thData.ao,thData.midori,thData.aka);

      if thData.hanten then
        cols[254]:=RGB(255-thData.shuB,255-thData.shuG,255-thData.shuR)
      else
        cols[254]:=RGB(thData.shuB,thData.shuG,thData.shuR);

      for i:=0 to nn do
      begin

        aka:=thData.rn*i+thData.rc;
        midori:=thData.gn*i+thData.gc;
        ao:=thData.bn*i+thData.bc;

        if aka>255 then
          aka:=255;

        if midori>255 then
          midori:=255;

        if ao>255 then
          ao:=255;

        if aka<0 then
          aka:=0;

        if midori<0 then
          midori:=0;

        if ao<0 then
          ao:=0;

        if thData.hanten then
          cols[i]:=RGB(255-ao,255-midori,255-aka)
        else
          cols[i]:=RGB(ao,midori,aka);

      end;

      dx:=thData.range/400.0;
      dy:=dx;

      points:=clpoints; // UNA

      for i:=0 to 399 do  // `{
      begin

        if thData.mand then  // }fuW
        begin

          for j:=0 to 399 do // 񕪌vZ
          begin

            znr:=0;
            zni:=0;
            thData.jx:=thData.sx+dx*j;
            thData.jy:=thData.sy+dy*i;
            n:=0;

            repeat

              znr2:=(znr*znr)-(zni*zni)+thData.jx;
	      zni2:=(znr*zni)*2.0+thData.jy;

	      znr:=znr2;
	      zni:=zni2;

	      n:=n+1;

            until (n=600) or ((znr*znr+zni*zni)>4.0);

            points[j,i]:=n;

            if bSetOnly then
            begin

              if n=600 then // 񐔂ɉĐFÂ
                pixs[i mod 4,j]:=cols[255]
              else
                pixs[i mod 4,j]:=cols[0];

            end
            else
            begin

              if n=600 then // 񐔂ɉĐFÂ
                pixs[i mod 4,j]:=cols[255]
              else if n>nn then
                pixs[i mod 4,j]:=cols[254]
              else
                pixs[i mod 4,j]:=cols[n];

            end;

          end;

        end
        else  // WAW
        begin

          if (thData.jx*thData.jx+thData.jy*thData.jy)>4.0 then
            mc:=thData.jx*thData.jx+thData.jy*thData.jy
          else
            mc:=4.0;

          for j:=0 to 399 do // 񕪌vZ
          begin

            znr:=thData.sx+dx*j;
            zni:=thData.sy+dy*i;
            n:=0;

            repeat

              znr2:=(znr*znr)-(zni*zni)+thData.jx;
	      zni2:=(znr*zni)*2.0+thData.jy;

              znr:=znr2;
	      zni:=zni2;

	      n:=n+1;

            until (n=600) or ((znr*znr+zni*zni)>mc);

            points[j,i]:=n;

            if bSetOnly then
            begin

              if n=600 then
                pixs[i mod 4,j]:=cols[255]
              else
                pixs[i mod 4,j]:=cols[0];

            end
            else
            begin

              if n=600 then
                pixs[i mod 4,j]:=cols[255]
              else if n>nn then
                pixs[i mod 4,j]:=cols[254]
              else
                pixs[i mod 4,j]:=cols[n];

            end;

          end;

        end;

        if not(go=1) or Terminated then
          break;

        py:=i; // ݕ`Ăy W

        if (py+1) mod 4=0 then
          Synchronize(drawScreen); // ʂɕ\

      end;

    end;

    doing:=False; // `撆tOZbg
    Synchronize(drawEnd); // Iii֌Wj

    if go=2 then // ăX^[g
      go:=1
    else if not Terminated then // ʏ̕`IȂ~
    begin

      dwTime2:=GetTickCount()-dwTime1;

      Form1.stStatus.SimpleText:='`掞:'+IntToStr(dwTime2)+'ms';

      Suspend;

    end;

  end;

end;

procedure TRunThread.drawScreen; // `
begin

  if not(Terminated) then
    StretchDIBits(Form1.Screen.Picture.Bitmap.Canvas.Handle,
      0,399-py,400,4,0,0,400,4,@pixs,bmi,
      DIB_RGB_COLORS,SRCCOPY); // DIBʂɕ`

  Form1.Screen.Refresh;

end;

procedure TRunThread.clearScreen; // ʃNA
begin

  Form1.screen.Picture.Bitmap.Canvas.brush.Color:=clBlack; // ʏ
  Form1.screen.Picture.Bitmap.Canvas.fillRect(Rect(0,0,400,400));
  Form1.screen.Refresh;

  Form1.CtrButton.Caption:=' ~(&C)';
  Form1.FileMenu.Enabled:=False;

end;

procedure TRunThread.drawEnd;
begin

  Form1.CtrButton.Caption:='J n(&G)';
  Form1.FileMenu.Enabled:=True;

end;

end.
